Attribute VB_Name = "LLParser"
Option Explicit




Public Type Production
  NonTerm As String
  SymbolList As Variant
End Type
  

Public Type Parser
  TermList As New Collection 'I[L
  NontermList As New Collection 'I[L
  
  'K
  NumProd As Long
  ProdList() As Production
  
  '\쐬
  First() As Collection
  Follow() As Collection
  Table() As Production
End Type


Public Function CreateParser(Grammer() As String) As Parser
Dim P As Parser
Dim i&, j&, k&
Dim stl(2) As Variant
Dim Term As String

'͂ꂽ@̃p[X
Call ParseGrammer(Grammer, P)

'\쐬s
Call CreateFirst(P)
Call CreateFollow(P)
Call CreateTable(P)
CreateParser = P

End Function

'ۂ̍\
Public Function ParseTokenlist(P As Parser, StartSymbol As String, Tokenlist() As TokenCls) As TTNode
Dim TopNode As New TTNode
Dim BottomNode As New TTNode
Dim TmpNode As TTNode
Dim TmpNode2 As TTNode
Dim Stack As New Collection
Dim i&, j&, Token As TokenCls
Dim prod As Production
Dim ni&, ti&

'X^bNɏlς
TopNode.Label = StartSymbol
BottomNode.Label = "$"
Stack.Add BottomNode
Stack.Add TopNode

i = 0
Do
  If i > UBound(Tokenlist) Then
    TopNode.Label = "$$ G["
    Set ParseTokenlist = TopNode
    Exit Function
  End If
  
  Set Token = Tokenlist(i)
  Set TmpNode = Stack(Stack.Count)
  
  'I[L̏ꍇ
  If IsTerm(TmpNode.Label) Or TmpNode.Label = "$" Then
    If TmpNode.Label = Token.Symbol Then
      Set TmpNode.Token = Token
      i = i + 1
      Call Stack.Remove(Stack.Count)
    Else
      'ׂ񂪂Ȃ
      TopNode.Label = "$$ [ " + TmpNode.Label + " ]ׂƂ [ " + Token.Symbol + " ]Ă܂"
      Set ParseTokenlist = TopNode
      Exit Function
    End If
  Else
    'I[L̏ꍇ
    ni = IndexInCollection(TmpNode.Label, P.NontermList) - 1
    If Token.Symbol = "$" Then
      ti = P.TermList.Count
    Else
      ti = IndexInCollection(Token.Symbol, P.TermList) - 1
      If ti < 0 Then
        TopNode.Label = "$$ g[N[ " + Token.Symbol + " ]͕@ɑ݂܂"
        Set ParseTokenlist = TopNode
        Exit Function
      End If
    End If
    
    prod = P.Table(ni, ti)
    
    'e[uȂꍇ
    If prod.NonTerm = "" Then
      TopNode.Label = "$$ M[" + TmpNode.Label + "," + Token.Symbol + "]ɑΉ郋[܂"
      Set ParseTokenlist = TopNode
      Exit Function
    End If
    
    'X := Y1 Y2 Y3EEEɑ΂ċtɐς
    Call Stack.Remove(Stack.Count)
    If prod.SymbolList(0) <> "#" Then
      For j = UBound(prod.SymbolList) To 0 Step -1
        Set TmpNode2 = New TTNode
        TmpNode2.Label = prod.SymbolList(j)
        Call Stack.Add(TmpNode2)
      Next
      For j = 0 To UBound(prod.SymbolList)
        Call TmpNode.SubNode.Add(Stack(Stack.Count - j))
      Next
    End If
  End If
  
Loop While i < UBound(Tokenlist)

Set ParseTokenlist = TopNode


End Function


Public Function ParseGrammer(Grammer() As String, P As Parser)
Dim i&, j&, k&
Dim stl(2) As Variant
Dim NonTerm As String

'͕@parse

For i = 0 To UBound(Grammer)
  'ӁEEӂ̕
  stl(0) = SplitString(Grammer(i), ":=")
  For j = 0 To UBound(stl(0))
    stl(0)(j) = Trim(stl(0)(j))
  Next
  
  If UBound(stl(0)) >= 1 And stl(0)(0) <> "" Then
    ' | ɂ镪
    stl(1) = SplitString(stl(0)(1), "|")
    
    '`̒ǉ
    For j = 0 To UBound(stl(1))
      Call AddProduction(P, CStr(stl(0)(0)), CStr(Trim(stl(1)(j))))
    Next
  End If
Next

End Function


Public Sub AddProduction(P As Parser, NonTerm As String, Rule As String)
Dim i&, j&
Dim stl As Variant
Dim t As Variant
Dim b As Boolean
Dim s$
Dim prod As Production

'Xy[XɂPPʂ̕
'Xy[X̍폜
Do While InStr(Rule, "  ") > 0
  Rule = Left(Rule, InStr(Rule, "  ") - 1) + Right(Rule, Len(Rule) - InStr(Rule, "  "))
Loop

'Xy[Xŕ
stl = SplitString(Rule, " ")

'g[N̒ǉ

'I[LXgɒǉ
Call AddSet(NonTerm, P.NontermList)

'eLi[
For i = 0 To UBound(stl)
  s = stl(i)
  If Len(s) > 0 Then
    
    'I[L
    If Left(s, 1) >= "A" And Left(s, 1) <= "Z" Then
      Call AddSet(s, P.NontermList)
    Else
      'I[L
      Call AddSet(s, P.TermList)
    End If
    
  End If
Next

prod.NonTerm = NonTerm
prod.SymbolList = stl
P.NumProd = P.NumProd + 1
ReDim Preserve P.ProdList(P.NumProd) As Production
P.ProdList(P.NumProd - 1) = prod

End Sub

Public Sub AddSet(val As Variant, ByRef col As Collection)
'RNVɏdȂ̒ǉ
Dim t As Variant

For Each t In col
  If t = val Then Exit Sub
Next
Call col.Add(val)

End Sub

Public Sub CreateFirst(P As Parser)
'FIRST̏W
Dim i&, j&, k&
Dim b As Boolean, b2 As Boolean
Dim prod As Production
Dim TC As Collection, TC2 As Collection
Dim s As Variant

'
ReDim P.First(P.NontermList.Count - 1) As Collection
For i = 0 To UBound(P.First)
  Set P.First(i) = New Collection
Next

Do
  b = False
  
  For i = 0 To P.NumProd - 1
    prod = P.ProdList(i)
    j = IndexInCollection(prod.NonTerm, P.NontermList)
    If j = -1 Then MsgBox "ERROR"
    Set TC = P.First(j - 1)
        
    'CvV̏ꍇ
    If prod.SymbolList(0) = "#" Then
      'FIRSTɃCvVǉ
      b = b Or AddToCollection("#", TC)
    Else
      'ȊȌꍇ
      'A B C DEEEƂACvV̂ƂTčs
      
      For j = 0 To UBound(prod.SymbolList)
        'jԖڂ܂ł̍ڂSăCvVH
        b2 = True
        For k = 0 To j - 1
          s = prod.SymbolList(k)
          'I[LȂɃCvVł͂Ȃ
          If s <> "#" And IsTerm(s) Then
            b2 = False
            Exit For
          Else
            '̔I[LFIRSTɃCvV܂܂邩H
            b2 = b2 And (IndexInCollection("#", P.First(IndexInCollection(s, P.NontermList) - 1)) >= 0)
          End If
        Next
        
        '܂܂ȂȂI
        If b2 = False Then Exit For
        
        'jԖڂ̍ڂFIRSTǉ
        s = prod.SymbolList(j)
        If IsTerm(s) Then
          'I[L͂ꎩ̂FIRST̗vf
          b = b Or AddToCollection(s, TC)
        Else
          'I[LȂeFIRSTǉ
          Set TC2 = P.First(IndexInCollection(s, P.NontermList) - 1)
          For k = 1 To TC2.Count
            b = b Or AddToCollection(TC2.Item(k), TC)
          Next
        End If
      Next
    End If
  Next
Loop While b 'ωȂ܂Ń[v


End Sub


Public Sub CreateFollow(P As Parser)
'FIRST̏W
Dim i&, j&, k&
Dim b As Boolean, b2 As Boolean
Dim prod As Production
Dim TC As Collection, TC2 As Collection, TC3 As Collection
Dim s As Variant

'
ReDim P.Follow(P.NontermList.Count - 1) As Collection
For i = 0 To UBound(P.First)
  Set P.Follow(i) = New Collection
Next

'sLǉ
P.Follow(0).Add "$"

'ωȂȂ܂ŌJԂ
Do
  b = False
  
  For i = 0 To P.NumProd - 1
    prod = P.ProdList(i)
    
    'eXgɂĒׂčs
    'A := a b cEEÊƂ AFollow
    j = IndexInCollection(prod.NonTerm, P.NontermList)
    If j = -1 Then MsgBox "ERROR"
    Set TC = P.Follow(j - 1)
    
    'Xg̊eI[LɂČvZ
    For j = 0 To UBound(prod.SymbolList)
      If IsTerm(prod.SymbolList(j)) = False Then
      
        'I[L̏ꍇ
        k = IndexInCollection(prod.SymbolList(j), P.NontermList)
        If k = -1 Then MsgBox "ERROR"
        Set TC3 = P.Follow(k - 1)
        
        '̃XgFIRST𓾂
        Set TC2 = GetListFirst(P, prod.SymbolList, j + 1)
        'CvVȊOǉ
        For Each s In TC2
          If s <> "#" Then b = b Or AddToCollection(s, TC3)
        Next
        'Ō͍Ō܂ŃCvVœB
        If IndexInCollection("#", TC2) > 0 Or j = UBound(prod.SymbolList) Then
          For Each s In TC
            b = b Or AddToCollection(s, TC3)
          Next
        End If
      End If
    Next
  Next
Loop While b 'ωȂ܂Ń[v


End Sub


Public Sub CreateTable(P As Parser)
Dim i&, j&
Dim prod As Production
Dim First As Collection
Dim Follow As Collection
Dim s As Variant
Dim ni&, ti&

'
ReDim P.Table(P.NontermList.Count - 1, P.TermList.Count) As Production

'e[Ƃɏ
For i = 0 To P.NumProd - 1
  prod = P.ProdList(i)
  ni = IndexInCollection(prod.NonTerm, P.NontermList) - 1
  Set Follow = P.Follow(ni)
  
  
  Set First = GetListFirst(P, prod.SymbolList, 0)
  
  'eI[Lɂď
  For Each s In First
    'I[L̏ꍇ
    If IsTerm(s) And s <> "#" Then
      ti = IndexInCollection(s, P.TermList) - 1
      If P.Table(ni, ti).NonTerm <> "" Then
        'dĂ܂ꍇ
        MsgBox "M[" + prod.NonTerm + "," + s + "] ŏd"
      Else
        P.Table(ni, ti) = prod
      End If
    End If
  Next
  
  'FIRSTɃCvV܂ޏꍇ
  If IndexInCollection("#", First) >= 0 Then
    For Each s In Follow
      If s = "$" Then
        ti = P.TermList.Count
      Else
        ti = IndexInCollection(s, P.TermList) - 1
      End If
      
      If P.Table(ni, ti).NonTerm <> "" Then
        'dĂ܂ꍇ
        MsgBox "M[" + prod.NonTerm + "," + s + "] ŏd"
      Else
        P.Table(ni, ti) = prod
      End If
    Next
  End If
Next

End Sub


Public Function IsTerm(ByVal Symbol As String) As Boolean
'I[Lǂ
Dim s$

If Len(Symbol) = 0 Then Exit Function

s = Left(Symbol, 1)

If s >= "A" And s <= "Z" Then
  IsTerm = False
Else
  IsTerm = True
End If


End Function


Public Function AddToCollection(ByVal val As Variant, col As Collection) As Boolean
'd̒ǉ
Dim b As Boolean
Dim t As Variant

b = True
For Each t In col
  If t = val Then b = False
Next

If b Then col.Add val
AddToCollection = b

End Function

Public Function IndexInCollection(ByVal val As Variant, col As Collection) As Long
'w荀ڂ݂邩H݂ȂȂ-1A݂炻̃CfbNX
Dim i&

IndexInCollection = -1
For i = 1 To col.Count
  If col.Item(i) = val Then IndexInCollection = i
Next

End Function


Public Function GetListFirst(P As Parser, val As Variant, index As Long) As Collection
'g[NFirst擾
'͒l̓g[NzVariantlƊJnʒuindex
Dim First As New Collection
Dim b As Boolean
Dim i&, j&, k&
Dim TC As Collection
Dim s As Variant

For i = index To UBound(val)
  b = False
  
  If val(i) = "#" Then
    b = True
  ElseIf IsTerm(val(i)) Then
    'I[L
    Call AddToCollection(val(i), First)
  Else
    'I[L
    '#ȊOSĒǉ
    Set TC = P.First(IndexInCollection(val(i), P.NontermList) - 1)
    For Each s In TC
      If s = "#" Then
        b = True
      Else
        Call AddToCollection(s, First)
      End If
    Next
  End If
  
  If b = False Then Exit For
Next

If b Then Call AddToCollection("#", First)

Set GetListFirst = First

End Function

Public Function TableToString(P As Parser) As String
'e[u̒g\
Dim i&, j&, k&
Dim s$
Dim ns$, ts$, t$

For i = 0 To P.NontermList.Count - 1
  For j = 0 To P.TermList.Count
    ns = P.NontermList(i + 1)
    
    If j < P.TermList.Count Then
      ts = P.TermList(j + 1)
    Else
      ts = "$"
    End If
  
    s = s + "M[" + ns + "," + ts + "] F "
    If P.Table(i, j).NonTerm <> "" Then
      s = s + ns + " := "
      For k = 0 To UBound(P.Table(i, j).SymbolList)
        s = s + P.Table(i, j).SymbolList(k) + " "
      Next
    End If
    s = s + vbCrLf
  Next
  s = s + vbCrLf
Next

TableToString = s

End Function


Public Sub StringToTokenlist(Prog As String, Token() As TokenCls)
'𕪊ATokenNXz쐬
Dim s As Variant
Dim t$
Dim i&

t = Prog

'^uƉs󔒂ɒu
t = ReplaceString(t, vbTab, " ")
t = ReplaceString(t, vbCrLf, " ")

'Xy[X̘A폜
Do While InStr(t, "  ") > 0
  t = Left(t, InStr(t, "  ") - 1) + Right(t, Len(t) - InStr(t, "  "))
Loop

t = Trim(t)

s = SplitString(t, " ")
ReDim Token(UBound(s) + 1) As TokenCls
For i = 0 To UBound(Token) - 1
  Set Token(i) = New TokenCls
  Token(i).Symbol = s(i)
Next
'L
Set Token(UBound(Token)) = New TokenCls
Token(UBound(Token)).Symbol = "$"

End Sub

'm[h𕶎ɓWJ
Public Function NodeTreeToString(Node As TTNode, StrType As Boolean) As String
Dim i&
Dim s$, t$
Dim b As Boolean

If Node.SubNode.Count = 0 Then
  If IsTerm(Node.Label) Then
    s = Node.Label
  ElseIf StrType Then
    s = Node.Label + "[]"
  End If
    
ElseIf Node.SubNode.Count > 0 Then
  If StrType Then
    s = Node.Label + "["
    For i = 0 To Node.SubNode.Count - 1
      s = s + NodeTreeToString(Node.SubNode(i + 1), StrType)
      If i < Node.SubNode.Count - 1 Then s = s + " "
    Next
    s = s + "]"
  Else
    For i = 0 To Node.SubNode.Count - 1
      t = NodeTreeToString(Node.SubNode(i + 1), StrType)
      If t <> "" Then
        If s <> "" Then
          s = s + " "
          b = True
        End If
        s = s + t
      End If
    Next
    If b Then s = "[" + s + "]"
  End If
End If

NodeTreeToString = s

End Function








Function ReplaceString(ByVal target As String, ByVal FromString As String, ByVal ToString As String) As String
Dim a$, b$, c$, d$, i&, j&, k&
'u
'VB6ȂsvAVB5ɂReplace֐Ȃ
a = target
b = FromString
c = ToString
j = Len(FromString)
k = Len(ToString)

i = InStr(a, b)
Do While i <> 0
'u
a = Left(a, i - 1) + c + Right(a, Len(a) - i - j + 1)
i = InStr(i + k, a, b)
Loop

ReplaceString = a

End Function


Function SplitString(ByVal target As String, ByVal Splitter As String) As Variant
'w肵ŕ
'Splitter͂PAKvȂReplaceString𗘗p
'VB6ȂsvAVB5ɂSplit֐Ȃ
Dim st$()
Dim i&, j&, k&, s$, l&, l2&

i = 1
l = Len(target)
l2 = Len(Splitter)
For j = 1 To l - l2 + 1
  If Mid(target, j, l2) = Splitter Then
    s = Mid(target, i, j - i)
    ReDim Preserve st(k) As String
    st(k) = s
    i = j + l2
    k = k + 1
  End If
Next

s = Mid(target, i, j - i + 1)
ReDim Preserve st(k) As String
st(k) = s

SplitString = st
End Function



